using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;
using System.Text;
using Servico.servidorSACI;

namespace Servico
{
    public abstract class cBaseServico : ServiceBase
    {

        protected bool modoDebug = true;

        protected void GerarLogFileSystem(string mensagem)
        {
            try
            {
                string diretorio = System.AppDomain.CurrentDomain.BaseDirectory + "\\LOG\\";
                if (!System.IO.Directory.Exists(diretorio))
                    System.IO.Directory.CreateDirectory(diretorio);

                string nomeArquivo = "SERVICO-SACI-{0}-{1}-{2}.log";
                nomeArquivo = string.Format(nomeArquivo, DateTime.Now.Year, DateTime.Now.Month.ToString().PadLeft(2, '0'), DateTime.Now.Day.ToString().PadLeft(2, '0'));

                string filename = diretorio + nomeArquivo;
                System.IO.StreamWriter sw = new System.IO.StreamWriter(filename, true, System.Text.Encoding.Default);
                string linha = "[{0}] {1}";
                linha = string.Format(linha, DateTime.Now.ToString("dd/MM/yyyy HH:mm:ss"), mensagem);
                sw.WriteLine(linha);
                sw.Close();
            }
            catch { }
        }

        protected String ObterParametro(String parametro)
        {
            return System.Configuration.ConfigurationManager.AppSettings[parametro];
        }

        protected void TratarErro(Exception ex)
        {
            GerarLogFileSystem("\n--------------------------------------------");
            GerarLogFileSystem("ERRO\n--------------------------------------------");
            GerarLogFileSystem("Mensagem: " + ex.Message);
            GerarLogFileSystem("Data: " + ex.Data);
            GerarLogFileSystem("--------------------------------------------");
            throw (ex);
        }
    }
}
