using System;
using System.Collections.Generic;
using System.Text;

using Servico.servidorSACI;

namespace Servico
{
    class cMonitoramento : cBaseServico
    {
        //        private dsMonitoramento.DadosAMonitorarDataTable dsDados = new dsMonitoramento.DadosAMonitorarDataTable();
        private cSNMP cSNMP = new cSNMP();
        private dsMonitoramento dsDados = new dsMonitoramento();
        private SACIWebService webService = new SACIWebService();
        private String chaveColetor;
        private String identificacaoColetor;

        public void Monitorar()
        {
            chaveColetor = ObterParametro("chaveColetor");
            identificacaoColetor = ObterParametro("IdentificacaoColetor");
            

            ObterListaDeDadosAMonitorar();
            ColetarDados();
            EnviarDados();

        }

        private void ObterListaDeDadosAMonitorar()
        {
            try
            {
                if (base.modoDebug == true)
                {
                    //GerarLogFileSystem(dsDados.GetXml());
                    GerarLogFileSystem("Buscando Lista de Dados do Servidor " + webService.Url + " - quantidade registros: " + dsDados.DadosAMonitorar.Rows.Count.ToString() + "\n \n");
                }

                dsDados = webService.RetornarICsParaMonitoramento(chaveColetor, identificacaoColetor);

            }
            catch (Exception ex)
            {
                TratarErro(ex);
            }
        }

        private void ColetarDados()
        {
            String dado;
            dsMonitoramento.RetornoMonitoramentoRow retornoRow; //= dsDados.RetornoMonitoramento.NewRetornoMonitoramentoRow();

            //System.Data.DataRow retornoRow = dsDados.RetornoMonitoramento.NewRetornoMonitoramentoRow(); 
            //retornoRow = dsDados.RetornoMonitoramento.NewRetornoMonitoramentoRow();

            try
            {
                foreach (System.Data.DataRow linha in dsDados.DadosAMonitorar)
                {
                    dado = cSNMP.ObterValorViaSnmp(linha["IP"].ToString(), linha["OID"].ToString());

                    if (dado.Length < 6 || dado.Substring(0, 6) != "<ERRO>")
                    {
                        if (modoDebug == true) GerarLogFileSystem("Coletando <" + linha["ColetorResponsavel"] + "><" + linha["ID_ConfiguracaoMonitoramento"] + "><" + linha["IP"] + "><" + linha["OID"] + "> - Valor: " + dado);

                        retornoRow = dsDados.RetornoMonitoramento.NewRetornoMonitoramentoRow();
                        retornoRow.ID_ConfiguracaoMonitoramento = int.Parse(linha["ID_ConfiguracaoMonitoramento"].ToString());
                        retornoRow.ID_ICAtributo = int.Parse(linha["ID_ICAtributo"].ToString());
                        retornoRow.Valor = dado;

                        dsDados.RetornoMonitoramento.AddRetornoMonitoramentoRow(retornoRow);

                    }
                    else if (modoDebug == true)
                        GerarLogFileSystem("Erro ao coletar <" + linha["ColetorResponsavel"] + "><" + linha["ID_ConfiguracaoMonitoramento"] + "><" + linha["IP"] + "><" + linha["OID"] + ">\nDetalhes do Erro:" + dado);
                }

            }
            catch (Exception ex)
            {
                TratarErro(ex);
            }

        }

        private void EnviarDados()
        {

            try
            {

                
                if (modoDebug == true) GerarLogFileSystem("Enviando " + dsDados.RetornoMonitoramento.Rows.Count.ToString());

                webService.ObterResultadoMonitoramento(chaveColetor, dsDados);

                //webService.RetornarICsParaMonitoramento(chaveColetor, identificacaoColetor);

                //foreach (System.Data.DataRow linha in dsDados)
                //{
                //    dado = cSNMP.ObterValorViaSnmp(linha["IP"].ToString(), linha["OID"].ToString());

                //    if (dado.Length < 6 || dado.Substring(0, 6) != "<ERRO>")
                //    {
                //        if (modoDebug == true) GerarLogFileSystem("Coletando <" + linha["ColetorResponsavel"] + "><" + linha["ID_ConfiguracaoMonitoramento"] + "><" + linha["IP"] + "><" + linha["OID"] + "> - Valor: " + dado);

                //        retornoRow.ID_ConfiguracaoMonitoramento = int.Parse(linha["ID_ConfiguracaoMonitoramento"].ToString());
                //        retornoRow.Valor = dado;

                //        dsDados.RetornoMonitoramento.AddRetornoMonitoramentoRow(retornoRow);

                //    }
                //    else if (modoDebug == true)
                //        GerarLogFileSystem("Erro ao coletar <" + linha["ColetorResponsavel"] + "><" + linha["ID_ConfiguracaoMonitoramento"] + "><" + linha["IP"] + "><" + linha["OID"] + ">");
                //}

            }
            catch (Exception ex)
            {
                TratarErro(ex);
            }

        }
    }
}
