using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using SACI.Comum.DataSet;

namespace SACI.AcessoDados
{
    public class cAlerta : cBaseAcessoDados
    {


        // Lista todos os alertas de um atributo 
        public void ListarAlerta(dsAlerta ds, int tipo)
        {
            selectCommand = new SqlCommand();

            selectCommand.Parameters.Add(new SqlParameter("@TipoPesquisa", tipo));

            base.DoSelect(ds, "p_ListarAlerta", ds.Alerta.TableName);
        }

        // Lista todos os alertas de um atributo 
        public void ListarConfiguracaoAlerta(dsAlerta ds, int id_ICAtributo)
        {
            selectCommand = new SqlCommand();
            //
            //if (id_ICAtributo != 0)
                selectCommand.Parameters.Add(new SqlParameter("@ID_ICAtributo", id_ICAtributo));

            //
            base.DoSelect(ds, "p_ListarConfiguracaoAlerta", ds.ConfiguracaoAlerta.TableName);
        }

        //lista um alerta especfico, atravs de seu ID
        public void ListarConfiguracaoAlertaEspecifico(dsAlerta ds, int id_ConfiguracaoAlerta)
        {
            selectCommand = new SqlCommand();
            //
            if (id_ConfiguracaoAlerta != 0)
                selectCommand.Parameters.Add(new SqlParameter("@ID_ConfiguracaoAlerta", id_ConfiguracaoAlerta));

            //
            base.DoSelect(ds, "p_ListarConfiguracaoAlertaEspecifico", ds.ConfiguracaoAlerta.TableName);
        }

        public int SalvarConfiguracaoAlerta(dsAlerta.ConfiguracaoAlertaRow configuracaoAlertaRow)
        {
            dsAlerta.ConfiguracaoAlertaRow configuracaoAlertaAnteriorRow = RetornaValorAnteriorConfiguracaoAlerta(configuracaoAlertaRow.ID_ConfiguracaoAlerta);

            selectCommand = new SqlCommand();

            selectCommand.Parameters.Add(new SqlParameter("@ID_ConfiguracaoAlerta", configuracaoAlertaRow.ID_ConfiguracaoAlerta));
            selectCommand.Parameters.Add(new SqlParameter("@ID_ICAtributo", configuracaoAlertaRow.ID_ICAtributo));
            selectCommand.Parameters.Add(new SqlParameter("@Descricao", configuracaoAlertaRow.Descricao));
            selectCommand.Parameters.Add(new SqlParameter("@Quando", configuracaoAlertaRow.Quando));
            selectCommand.Parameters.Add(new SqlParameter("@Media", configuracaoAlertaRow.Media));
            selectCommand.Parameters.Add(new SqlParameter("@Condicao", configuracaoAlertaRow.Condicao));
            selectCommand.Parameters.Add(new SqlParameter("@Valor", configuracaoAlertaRow.Valor));
            selectCommand.Parameters.Add(new SqlParameter("@IntervaloVerificacao", configuracaoAlertaRow.IntervaloVerificacao));
            selectCommand.Parameters.Add(new SqlParameter("@EnviaEmail", configuracaoAlertaRow.EnviaEmail));
            selectCommand.Parameters.Add(new SqlParameter("@EnviaMensagem", configuracaoAlertaRow.EnviaMensagem));
            selectCommand.Parameters.Add(new SqlParameter("@Ativo", configuracaoAlertaRow.Ativo));

            dsAlerta ds = new dsAlerta();
            base.DoSelect(ds, "p_SalvarConfiguracaoAlerta", "SalvarConfiguracaoAlerta");

            base.GeraTrilhaAuditoria(configuracaoAlertaRow.ID_ConfiguracaoAlerta, configuracaoAlertaAnteriorRow, configuracaoAlertaRow);

            return int.Parse(ds.SalvarConfiguracaoAlerta[0].Retorno.ToString());
        }

        private dsAlerta.ConfiguracaoAlertaRow RetornaValorAnteriorConfiguracaoAlerta(int ID_ConfiguracaoAlerta)
        {

            dsAlerta ds = new dsAlerta();

            dsAlerta.ConfiguracaoAlertaRow configuracaoAlertaAnteriorRow;

            if (ID_ConfiguracaoAlerta == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                configuracaoAlertaAnteriorRow = ds.ConfiguracaoAlerta.NewConfiguracaoAlertaRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                ListarConfiguracaoAlertaEspecifico(ds, ID_ConfiguracaoAlerta);
                configuracaoAlertaAnteriorRow = ds.ConfiguracaoAlerta[0];
            }

            return configuracaoAlertaAnteriorRow;

        }

        public void ExcluirConfiguracaoAlerta(dsAlerta.ConfiguracaoAlertaRow configuracaoAlertaRow)
        {

            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID_ConfiguracaoAlerta", configuracaoAlertaRow.ID_ConfiguracaoAlerta));

            dsFilial ds = new dsFilial();
            base.DoSelect(ds, "p_ExcluirConfiguracaoAlerta", "ExcluirConfiguracaoAlerta");

        }



    }
}

