using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using SACI.Comum.DataSet; 

namespace SACI.AcessoDados
{
    public class cDepartamento : cBaseAcessoDados 
    {

        public void Listar(dsDepartamento ds, int id, int tipoPesquisa)
        {
            //tipoPesquisa
            //1 - id do Departamento
            //2 - id da Filial

            selectCommand = new SqlCommand();

            if (id != 0)
            {
                if (tipoPesquisa == 1)
                {
                    selectCommand.Parameters.Add(new SqlParameter("@ID_Departamento", id));
                }
                else if (tipoPesquisa == 2)
                {
                    selectCommand.Parameters.Add(new SqlParameter("@ID_Filial", id));
                }
            }

            base.DoSelect(ds, "p_ListarDepartamento", ds.Departamento.TableName);
        }
        
        
       public void Listar(dsDepartamento ds, string clausulaWhere)
        {
            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ClausulaWhere", clausulaWhere));
            base.DoSelect(ds, "p_ListarDepartamento", ds.Departamento.TableName);
        }

        public int Salvar(dsDepartamento.DepartamentoRow departamento)
        {

            dsDepartamento.DepartamentoRow departamentoAnterior = RetornaValorAnterior(departamento.ID_Departamento);

            selectCommand = new SqlCommand();
            //
            selectCommand.Parameters.Add(new SqlParameter("@ID", departamento.ID_Departamento));
            selectCommand.Parameters.Add(new SqlParameter("@Departamento", departamento.Departamento));
            selectCommand.Parameters.Add(new SqlParameter("@ID_Filial", departamento.ID_Filial));
            //
            dsDepartamento ds = new dsDepartamento();
            base.DoSelect(ds, "p_SalvarDepartamento", "SalvarDepartamento");

            base.GeraTrilhaAuditoria(departamento.ID_Departamento, departamentoAnterior, departamento);

            //
            return int.Parse(ds.SalvarDepartamento[0].Retorno.ToString());
        }


        private dsDepartamento.DepartamentoRow RetornaValorAnterior(int ID_Departamento)
        {

            dsDepartamento ds = new dsDepartamento();

            dsDepartamento.DepartamentoRow departamentoAnterior;

            if (ID_Departamento == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                departamentoAnterior = ds.Departamento.NewDepartamentoRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                Listar(ds, ID_Departamento, 1);
                departamentoAnterior = ds.Departamento[0];
            }

            return departamentoAnterior;

        }

        public void Excluir(dsDepartamento.DepartamentoRow departamento)
        {

            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID", departamento.ID_Departamento));

            dsFilial ds = new dsFilial();
            base.DoSelect(ds, "p_ExcluirDepartamento", "ExcluirDepartamento");

        }


    }
}
