using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using SACI.Comum.DataSet;

namespace SACI.AcessoDados
{
    public class cEmpresa : cBaseAcessoDados
    {

        public void Listar(dsEmpresa ds, int id)
        {
            selectCommand = new SqlCommand();
            //
            if (id != 0)
                selectCommand.Parameters.Add(new SqlParameter("@ID_Empresa", id));

            //
            base.DoSelect(ds, "p_ListarEmpresa", ds.Empresa.TableName);
        }

        public void Listar(dsEmpresa ds, string clausulaWhere)
        {
            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ClausulaWhere", clausulaWhere));
            base.DoSelect(ds, "p_ListarEmpresa", ds.Empresa.TableName);
        }

        public int Salvar(dsEmpresa.EmpresaRow empresa)
        {

            dsEmpresa.EmpresaRow empresaAnterior = RetornaValorAnterior(empresa.ID_Empresa);
  
            selectCommand = new SqlCommand();
            //
            selectCommand.Parameters.Add(new SqlParameter("@ID", empresa.ID_Empresa));
            selectCommand.Parameters.Add(new SqlParameter("@CNPJ", empresa.CNPJ));
            selectCommand.Parameters.Add(new SqlParameter("@RazaoSocial", empresa.RazaoSocial));
            selectCommand.Parameters.Add(new SqlParameter("@Apelido", empresa.Apelido));
            selectCommand.Parameters.Add(new SqlParameter("@Endereco", empresa.Endereco));
            selectCommand.Parameters.Add(new SqlParameter("@Bairro", empresa.Bairro));
            selectCommand.Parameters.Add(new SqlParameter("@Cidade", empresa.Cidade));
            selectCommand.Parameters.Add(new SqlParameter("@UF", empresa.UF));
            selectCommand.Parameters.Add(new SqlParameter("@CEP", empresa.CEP));
            selectCommand.Parameters.Add(new SqlParameter("@complemento", empresa.Complemento));
            selectCommand.Parameters.Add(new SqlParameter("@Homepage", empresa.HomePage));
            selectCommand.Parameters.Add(new SqlParameter("@Email", empresa.Email));
            selectCommand.Parameters.Add(new SqlParameter("@Ativo", empresa.Ativo));
            //

            dsEmpresa ds = new dsEmpresa();
            base.DoSelect(ds, "p_SalvarEmpresa", "SalvarEmpresa");

            base.GeraTrilhaAuditoria(empresa.ID_Empresa, empresaAnterior, empresa);  

            return int.Parse(ds.SalvarEmpresa[0].Retorno.ToString());
        }

        private dsEmpresa.EmpresaRow RetornaValorAnterior(int ID_Empresa)
        {
            
            dsEmpresa ds = new dsEmpresa();

            dsEmpresa.EmpresaRow empresaAnterior;

            if (ID_Empresa == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                //                dsEmpresa.EmpresaRow empresaAnterior = ds.Empresa.NewEmpresaRow();
                empresaAnterior = ds.Empresa.NewEmpresaRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                Listar(ds, ID_Empresa);
                //                dsEmpresa.EmpresaRow empresaAnterior = ds.Empresa[0];
                empresaAnterior = ds.Empresa[0];
            }

            return empresaAnterior;
        
        }

        public void Excluir(dsEmpresa.EmpresaRow empresa)
        {

            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID", empresa.ID_Empresa));

            dsFilial ds = new dsFilial();
            base.DoSelect(ds, "p_ExcluirEmpresa", "ExcluirEmpresa");

        }



    }
}

