using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using SACI.Comum.DataSet; 

namespace SACI.AcessoDados
{
    public class cFilial : cBaseAcessoDados 
    {

        public void Listar(dsFilial ds, int id, int tipoPesquisa)
        {
            //tipoPesquisa
            //1 - id da Filial
            //2 - id da Empresa

            selectCommand = new SqlCommand();

            if (id != 0)
            {
                if (tipoPesquisa == 1)
                {
                    selectCommand.Parameters.Add(new SqlParameter("@ID_Filial", id));
                }
                else if (tipoPesquisa == 2) 
                {
                    selectCommand.Parameters.Add(new SqlParameter("@ID_Empresa", id));
                }
            }

            base.DoSelect(ds, "p_ListarFilial", ds.Filial.TableName);
        }

        public void Listar(dsFilial ds, string clausulaWhere)
        {
            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ClausulaWhere", clausulaWhere));
            base.DoSelect(ds, "p_ListarFilial", ds.Filial.TableName);
        }

        public int Salvar(dsFilial.FilialRow filial)
        {

            dsFilial.FilialRow filialAnterior = RetornaValorAnterior(filial.ID_Filial);

            selectCommand = new SqlCommand();
            //
            selectCommand.Parameters.Add(new SqlParameter("@ID", filial.ID_Filial));
            selectCommand.Parameters.Add(new SqlParameter("@Filial", filial.Filial));
            selectCommand.Parameters.Add(new SqlParameter("@ID_Empresa", filial.ID_Empresa));
            //
            dsFilial ds = new dsFilial();
            base.DoSelect(ds, "p_SalvarFilial", "SalvarFilial");

            base.GeraTrilhaAuditoria(filial.ID_Filial , filialAnterior, filial);  

            //
            return int.Parse(ds.SalvarFilial[0].Retorno.ToString());
        }

        private dsFilial.FilialRow RetornaValorAnterior(int ID_Filial)
        {

            dsFilial ds = new dsFilial();

            dsFilial.FilialRow filialAnterior;

            if (ID_Filial == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                filialAnterior = ds.Filial.NewFilialRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                Listar(ds, ID_Filial, 1);
                //                dsEmpresa.EmpresaRow empresaAnterior = ds.Empresa[0];
                filialAnterior = ds.Filial[0];
            }

            return filialAnterior;

        }

        public void Excluir(dsFilial.FilialRow filial)
        {

            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID", filial.ID_Filial));

            dsFilial ds = new dsFilial();
            base.DoSelect(ds, "p_ExcluirFilial", "ExcluirFilial");

        }


    }
}
