using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using SACI.Comum.DataSet;

namespace SACI.AcessoDados
{
    public class cFornecedor : cBaseAcessoDados
    {

        public void Listar(dsFornecedor ds, int id)
        {
            selectCommand = new SqlCommand();
            //
            if (id != 0)
                selectCommand.Parameters.Add(new SqlParameter("@id", id));

            //
            base.DoSelect(ds, "p_ListarFornecedor", ds.Fornecedor.TableName);
        }

        public void Listar(dsFornecedor ds, string clausulaWhere)
        {
            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ClausulaWhere", clausulaWhere));
            base.DoSelect(ds, "p_ListarFornecedor", ds.Fornecedor.TableName);
        }

        public int Salvar(dsFornecedor.FornecedorRow fornecedor)
        {

            dsFornecedor.FornecedorRow fornecedorAnterior = RetornaValorAnterior(fornecedor.ID_Fornecedor);

            selectCommand = new SqlCommand();
            //
            selectCommand.Parameters.Add(new SqlParameter("@ID", fornecedor.ID_Fornecedor));
            selectCommand.Parameters.Add(new SqlParameter("@CNPJ", fornecedor.CNPJ));
            selectCommand.Parameters.Add(new SqlParameter("@RazaoSocial", fornecedor.RazaoSocial));
            selectCommand.Parameters.Add(new SqlParameter("@Apelido", fornecedor.Apelido));
            selectCommand.Parameters.Add(new SqlParameter("@Endereco", fornecedor.Endereco));
            selectCommand.Parameters.Add(new SqlParameter("@Bairro", fornecedor.Bairro));
            selectCommand.Parameters.Add(new SqlParameter("@Cidade", fornecedor.Cidade));
            selectCommand.Parameters.Add(new SqlParameter("@UF", fornecedor.UF));
            selectCommand.Parameters.Add(new SqlParameter("@CEP", fornecedor.CEP));
            selectCommand.Parameters.Add(new SqlParameter("@complemento", fornecedor.Complemento));
            selectCommand.Parameters.Add(new SqlParameter("@Homepage", fornecedor.HomePage));
            selectCommand.Parameters.Add(new SqlParameter("@Email", fornecedor.Email));
            selectCommand.Parameters.Add(new SqlParameter("@Ativo", fornecedor.Ativo));
            //

            dsFornecedor ds = new dsFornecedor();
            base.DoSelect(ds, "p_SalvarFornecedor", "SalvarFornecedor");

            base.GeraTrilhaAuditoria(fornecedor.ID_Fornecedor, fornecedorAnterior, fornecedor);

            return int.Parse(ds.SalvarFornecedor[0].Retorno.ToString());
        }

        private dsFornecedor.FornecedorRow RetornaValorAnterior(int ID_Fornecedor)
        {

            dsFornecedor ds = new dsFornecedor();

            dsFornecedor.FornecedorRow fornecedorAnterior;

            if (ID_Fornecedor == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                //                dsFornecedor.FornecedorRow fornecedorAnterior = ds.Fornecedor.NewFornecedorRow();
                fornecedorAnterior = ds.Fornecedor.NewFornecedorRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                Listar(ds, ID_Fornecedor);
                //                dsFornecedor.FornecedorRow fornecedorAnterior = ds.Fornecedor[0];
                fornecedorAnterior = ds.Fornecedor[0];
            }

            return fornecedorAnterior;

        }
        public void Excluir(dsFornecedor.FornecedorRow fornecedor)
        {

            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID", fornecedor.ID_Fornecedor));

            dsFornecedor ds = new dsFornecedor();
            base.DoSelect(ds, "p_ExcluirFornecedor", "ExcluirFornecedor");

        }


    }
}

