using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using SACI.Comum.DataSet;

namespace SACI.AcessoDados
{
    public class cLink : cBaseAcessoDados
    {

        public void Listar(dsLink ds, int id)
        {
            selectCommand = new SqlCommand();
            //
            if (id != 0)
                selectCommand.Parameters.Add(new SqlParameter("@ID_Link", id));

            //
            base.DoSelect(ds, "p_ListarLink", ds.Link.TableName);
        }

        public void Listar(dsLink ds, string clausulaWhere)
        {
            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ClausulaWhere", clausulaWhere));
            base.DoSelect(ds, "p_ListarLink", ds.Link.TableName);
        }

        public int Salvar(dsLink.LinkRow Link)
        {

            dsLink.LinkRow LinkAnterior = RetornaValorAnterior(Link.ID_Link);
  
            selectCommand = new SqlCommand();
            //
            selectCommand.Parameters.Add(new SqlParameter("@ID", Link.ID_Link));
            selectCommand.Parameters.Add(new SqlParameter("@Descricao", Link.Descricao));
            selectCommand.Parameters.Add(new SqlParameter("@Nome", Link.Nome));
            selectCommand.Parameters.Add(new SqlParameter("@Status", Link.Status));
            selectCommand.Parameters.Add(new SqlParameter("@ID_NodoA", Link.ID_NodoA));
            selectCommand.Parameters.Add(new SqlParameter("@ID_NodoB", Link.ID_NodoB));
            //

            dsLink ds = new dsLink();
            base.DoSelect(ds, "p_SalvarLink", "SalvarLink");

            base.GeraTrilhaAuditoria(Link.ID_Link, LinkAnterior, Link);  

            return int.Parse(ds.SalvarLink[0].Retorno.ToString());
        }

        private dsLink.LinkRow RetornaValorAnterior(int ID_Link)
        {
            
            dsLink ds = new dsLink();

            dsLink.LinkRow LinkAnterior;

            if (ID_Link == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                //                dsLink.LinkRow LinkAnterior = ds.Link.NewLinkRow();
                LinkAnterior = ds.Link.NewLinkRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                Listar(ds, ID_Link);
                //                dsLink.LinkRow LinkAnterior = ds.Link[0];
                LinkAnterior = ds.Link[0];
            }

            return LinkAnterior;
        
        }

        public void Excluir(dsLink.LinkRow Link)
        {

            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID", Link.ID_Link));

            dsFilial ds = new dsFilial();
            base.DoSelect(ds, "p_ExcluirLink", "ExcluirLink");

        }



    }
}

