using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using SACI.Comum.DataSet; 

namespace SACI.AcessoDados
{
    public class cTipoICAtributo : cBaseAcessoDados 
    {

        public void Listar(dsTipoIC ds, int id_TipoICAtributo, int id_TipoIC)
        {
            selectCommand = new SqlCommand();

            if (id_TipoICAtributo != 0)
                selectCommand.Parameters.Add(new SqlParameter("@id", id_TipoICAtributo));
            else if (id_TipoIC != 0)
                selectCommand.Parameters.Add(new SqlParameter("@id_TipoIC", id_TipoIC));
                
            base.DoSelect(ds, "p_ListarTipoICAtributo", ds.TipoICAtributo.TableName);
        }

        public void Listar(dsTipoIC ds, string clausulaWhere)
        {
            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ClausulaWhere", clausulaWhere));
            base.DoSelect(ds, "p_ListarTipoICAtributo", ds.TipoICAtributo.TableName);
        }

        public int Salvar(dsTipoIC.TipoICAtributoRow tipoICAtributo)
        {

            dsTipoIC.TipoICAtributoRow tipoICAtributoAnterior = RetornaValorAnterior(tipoICAtributo.ID_TipoICAtributo);

            selectCommand = new SqlCommand();
            //
            selectCommand.Parameters.Add(new SqlParameter("@ID", tipoICAtributo.ID_TipoICAtributo));
            selectCommand.Parameters.Add(new SqlParameter("@Descricao", tipoICAtributo.Descricao));
            selectCommand.Parameters.Add(new SqlParameter("@Observacoes", tipoICAtributo.Observacoes));
            selectCommand.Parameters.Add(new SqlParameter("@ID_TipoIC", tipoICAtributo.ID_TipoIC));
            //
            dsTipoIC ds = new dsTipoIC();
            base.DoSelect(ds, "p_SalvarTipoICAtributo", "SalvarTipoICAtributo");

            base.GeraTrilhaAuditoria(tipoICAtributo.ID_TipoICAtributo, tipoICAtributoAnterior, tipoICAtributo);

            //
            return int.Parse(ds.SalvarTipoICAtributo[0].Retorno.ToString());
        }


        private dsTipoIC.TipoICAtributoRow RetornaValorAnterior(int ID_TipoICAtributo)
        {

            dsTipoIC ds = new dsTipoIC();

            dsTipoIC.TipoICAtributoRow tipoICAtributoAnterior;

            if (ID_TipoICAtributo == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                tipoICAtributoAnterior = ds.TipoICAtributo.NewTipoICAtributoRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                Listar(ds, ID_TipoICAtributo, 0);
                tipoICAtributoAnterior = ds.TipoICAtributo[0];
            }

            return tipoICAtributoAnterior;

        }

        public void Excluir(dsTipoIC.TipoICAtributoRow tipoICAtributo)
        {

            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID", tipoICAtributo.ID_TipoICAtributo));

            dsTipoIC ds = new dsTipoIC();
            base.DoSelect(ds, "p_ExcluirTipoICAtributo", "ExcluirTipoICAtributo");

        }
    
    }
}
