using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using SACI.Comum.DataSet; 

namespace SACI.AcessoDados
{
    public class cTipoICAtributoEstado : cBaseAcessoDados 
    {

        public void Listar(dsTipoICAtributoEstado ds, int id_TipoICAtributoEstado, int id_TipoICAtributo)
        {
            selectCommand = new SqlCommand();

            if (id_TipoICAtributoEstado != 0)
                selectCommand.Parameters.Add(new SqlParameter("@id", id_TipoICAtributoEstado));
            else if (id_TipoICAtributo != 0)
                selectCommand.Parameters.Add(new SqlParameter("@id_TipoICAtributo", id_TipoICAtributo));
                
            base.DoSelect(ds, "p_ListarTipoICAtributoEstado", ds.TipoICAtributoEstado.TableName);
        }

        public void Listar(dsTipoICAtributoEstado ds, string clausulaWhere)
        {
            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ClausulaWhere", clausulaWhere));
            base.DoSelect(ds, "p_ListarTipoICAtributoEstado", ds.TipoICAtributoEstado.TableName);
        }

        public int Salvar(dsTipoICAtributoEstado.TipoICAtributoEstadoRow tipoICAtributoEstado)
        {

            dsTipoICAtributoEstado.TipoICAtributoEstadoRow tipoICAtributoEstadoAnterior = RetornaValorAnterior(tipoICAtributoEstado.ID_TipoICAtributoEstado);

            selectCommand = new SqlCommand();
            //
            selectCommand.Parameters.Add(new SqlParameter("@ID", tipoICAtributoEstado.ID_TipoICAtributoEstado));
            selectCommand.Parameters.Add(new SqlParameter("@Descricao", tipoICAtributoEstado.Descricao));
            selectCommand.Parameters.Add(new SqlParameter("@Observacoes", tipoICAtributoEstado.Observacoes));
            selectCommand.Parameters.Add(new SqlParameter("@ID_TipoICAtributo", tipoICAtributoEstado.ID_TipoICAtributo));
            //
            dsTipoICAtributoEstado ds = new dsTipoICAtributoEstado();
            base.DoSelect(ds, "p_SalvarTipoICAtributoEstado", "SalvarTipoICAtributoEstado");

            base.GeraTrilhaAuditoria(tipoICAtributoEstado.ID_TipoICAtributoEstado, tipoICAtributoEstadoAnterior, tipoICAtributoEstado);

            //
            return int.Parse(ds.SalvarTipoICAtributoEstado[0].Retorno.ToString());
        }


        private dsTipoICAtributoEstado.TipoICAtributoEstadoRow RetornaValorAnterior(int ID_TipoICAtributoEstado)
        {

            dsTipoICAtributoEstado ds = new dsTipoICAtributoEstado();

            dsTipoICAtributoEstado.TipoICAtributoEstadoRow tipoICAtributoEstadoAnterior;

            if (ID_TipoICAtributoEstado == 0)
            {
                // Se  um registro novo, retorna uma linha em branco
                tipoICAtributoEstadoAnterior = ds.TipoICAtributoEstado.NewTipoICAtributoEstadoRow();
            }
            else
            {
                // se existe um ID, pesquisa no banco de dados
                Listar(ds, ID_TipoICAtributoEstado, 0);
                tipoICAtributoEstadoAnterior = ds.TipoICAtributoEstado[0];
            }

            return tipoICAtributoEstadoAnterior;

        }
    
    
    }
}
