using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using SACI.Comum.DataSet;

namespace SACI.AcessoDados
{
    public class cUsuario : cBaseAcessoDados
    {
        public void Listar(dsUsuario ds, int id)
        {
            selectCommand = new SqlCommand();
            if (id != 0)
                selectCommand.Parameters.Add(new SqlParameter("@id", id));

            //
            base.DoSelect(ds, "p_ListarUsuario", ds.Usuario.TableName);
        }
         
        public void Listar(dsUsuario ds, string clausulaWhere)
        {
            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ClausulaWhere",clausulaWhere));
            base.DoSelect(ds, "p_ListarUsuario", ds.Usuario.TableName);
        }

        public int Salvar(dsUsuario.UsuarioRow usuario)
        {
            dsUsuario.UsuarioRow usuarioAnterior = RetornaValorAnterior(usuario.ID_Usuario);
            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID",usuario.ID_Usuario));
            selectCommand.Parameters.Add(new SqlParameter("@Login",usuario.Login));
            selectCommand.Parameters.Add(new SqlParameter("@Senha",usuario.Senha));
            selectCommand.Parameters.Add(new SqlParameter("@Nome",usuario.Nome));
            selectCommand.Parameters.Add(new SqlParameter("DataNascimento",usuario.DataNascimento));
            selectCommand.Parameters.Add(new SqlParameter("Celular",usuario.Celular));
            selectCommand.Parameters.Add(new SqlParameter("Telefone",usuario.Telefone));
            selectCommand.Parameters.Add(new SqlParameter("Email",usuario.Email));
            selectCommand.Parameters.Add(new SqlParameter("RG",usuario.RG));
            selectCommand.Parameters.Add(new SqlParameter("ID_Departamento",usuario.ID_Departamento));

            dsUsuario ds = new dsUsuario();
            base.DoSelect(ds,"p_SalvarUsuario","SalvarUsuario");

            base.GeraTrilhaAuditoria(usuario.ID_Usuario,usuarioAnterior,usuario);

            return int.Parse(ds.SalvarUsuario[0].Retorno.ToString());
        }

        public void Excluir(dsUsuario.UsuarioRow usuario)
        {

            selectCommand = new SqlCommand();
            selectCommand.Parameters.Add(new SqlParameter("@ID", usuario.ID_Usuario));

            dsUsuario ds = new dsUsuario();
            base.DoSelect(ds, "p_ExcluirUsuario", "ExcluirUsuario");

        }

        private dsUsuario.UsuarioRow RetornaValorAnterior(int ID_Usuario)
        {
            dsUsuario ds = new dsUsuario();
            dsUsuario.UsuarioRow usuarioAnterior;
            if (ID_Usuario == 0)
            {
                usuarioAnterior = ds.Usuario.NewUsuarioRow();
            }
            else
            {
                Listar(ds, ID_Usuario);
                usuarioAnterior = ds.Usuario[0];
            }
            return usuarioAnterior;
        }
    }
}
