using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using FluorineFx;
using SACI.Comum.DataSet;

namespace SACI.Negocio
{
    [RemotingService]
    public class cAlerta : cBaseNegocio
    {
        private SACI.AcessoDados.cAlerta cAcessoDados = new SACI.AcessoDados.cAlerta();
        private dsAlerta ds = new dsAlerta();
        private cIC cIC;

        public String Listar(int tipo)
        {
            cAcessoDados.ListarAlerta(ds, tipo);
            return ds.GetXml();
        }


        public String ListarConfiguracaoAlerta(int id)
        {
            cAcessoDados.ListarConfiguracaoAlerta(ds, id);
            return ds.GetXml();
        }

        public String RetornarModeloConfiguracaoAlerta()
        {
            return base.RetornarEstruturaDS(ds.ConfiguracaoAlerta);
        }


        public String SalvarConfiguracaoAlerta(String dados)
        {
            String retorno = "";

            try
            {
                dsAlerta.ConfiguracaoAlertaRow configuracaoAlertaRow;
                configuracaoAlertaRow = RetornarDataRow(ds, dados) as dsAlerta.ConfiguracaoAlertaRow;

                cAcessoDados.SalvarConfiguracaoAlerta(configuracaoAlertaRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }


        public String ExcluirConfiguracaoAlerta(String dados)
        {
            String retorno = "";

            try
            {
                dsAlerta.ConfiguracaoAlertaRow configuracaoAlertaRow;
                configuracaoAlertaRow = RetornarDataRow(ds, dados) as dsAlerta.ConfiguracaoAlertaRow;

                cAcessoDados.ExcluirConfiguracaoAlerta(configuracaoAlertaRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }


    }
}

