using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using FluorineFx;
using SACI.Comum.DataSet;

namespace SACI.Negocio
{
    [RemotingService]
    public class cMonitoramento : cBaseNegocio
    {
        private SACI.AcessoDados.cIC cAcessoDadosIC = new SACI.AcessoDados.cIC();
        private SACI.AcessoDados.cMonitoramento cAcessoDados = new SACI.AcessoDados.cMonitoramento();
        private dsMonitoramento ds = new dsMonitoramento();
        private cIC cIC;
        private cOID cOID;

        public String ListarConfiguracaoMonitoramento(int id)
        {
            cAcessoDados.ListarConfiguracaoMonitoramento(ds, id);
            return ds.GetXml();
        }

        public String RetornarModeloConfiguracaoMonitoramento()
        {
            return base.RetornarEstruturaDS(ds.ConfiguracaoMonitoramento);
        }

        public String ListarOID(int id_OID)
        {
            cAcessoDados.ListarOID(ds, id_OID);
            return ds.GetXml();
        }

        public String SalvarConfiguracaoMonitoramento(String dados)
        {
            String retorno = "";

            try
            {
                dsMonitoramento.ConfiguracaoMonitoramentoRow configuracaoMonitoramentoRow;
                configuracaoMonitoramentoRow = RetornarDataRow(ds, dados) as dsMonitoramento.ConfiguracaoMonitoramentoRow;

                cAcessoDados.SalvarConfiguracaoMonitoramento(configuracaoMonitoramentoRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }


        public String ExcluirConfiguracaoMonitoramento(String dados)
        {
            String retorno = "";

            try
            {
                dsMonitoramento.ConfiguracaoMonitoramentoRow configuracaoMonitoramentoRow;
                configuracaoMonitoramentoRow = RetornarDataRow(ds, dados) as dsMonitoramento.ConfiguracaoMonitoramentoRow;

                cAcessoDados.ExcluirConfiguracaoMonitoramento(configuracaoMonitoramentoRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }

        public String RetornarValorSnmp(int id_ConfiguracaoMonitoramento)
        {
            return "Lolo " + id_ConfiguracaoMonitoramento.ToString();
        }

        public dsMonitoramento RetornarDadosAMonitorar(String coletor)
        {

            cAcessoDados.ListarDadosAMonitorar(ds, coletor);
            return ds;            

        }

        public void SalvarDadosMonitorados(dsMonitoramento dsMonitoramento)
        {

            foreach (System.Data.DataRow linha in dsMonitoramento.RetornoMonitoramento)
            {
                cAcessoDadosIC.SalvarValorMonitoradoICAtributo(int.Parse(linha["ID_ICAtributo"].ToString()), linha["Valor"].ToString());
                
                cAcessoDados.AtualizarDataProximoMonitoramento(int.Parse(linha["ID_ConfiguracaoMonitoramento"].ToString()));


            }

        }


    }
}

