using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using FluorineFx;
using SACI.Comum.DataSet;

namespace SACI.Negocio
{
    [RemotingService]
    public class cPerfil : cBaseNegocio
    {
        private SACI.AcessoDados.cPerfil oAcessoDados = new SACI.AcessoDados.cPerfil();
        private dsPerfil ds = new dsPerfil();

        public String Listar(int id)
        {
            oAcessoDados.Listar(ds, id);
            return ds.GetXml();
        }

        public String RetornarModelo()
        {
            return base.RetornarEstruturaDS(ds.Perfil);
        }

        public String Salvar(String dados)
        {
            String retorno = "";

            try
            {
                dsPerfil.PerfilRow PerfilRow;
                PerfilRow = RetornarDataRow(ds, dados) as dsPerfil.PerfilRow;

                oAcessoDados.Salvar(PerfilRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }

        public String Excluir(String dados)
        {
            String retorno = "";

            try
            {
                dsPerfil.PerfilRow PerfilRow;
                PerfilRow = RetornarDataRow(ds, dados) as dsPerfil.PerfilRow;

                oAcessoDados.Excluir(PerfilRow);
            }
            catch (Exception ex)
            {
                retorno = ex.ToString();
            }

            return retorno;
        }


    }
}
