IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'p_ListarAlerta')
	BEGIN
		DROP  Procedure  p_ListarAlerta
	END

GO

CREATE Procedure dbo.p_ListarAlerta
	(
		@TipoPesquisa int
	)
AS

DECLARE @Where varchar(1000)

IF(@TipoPesquisa = 0) -- No Lidos
	BEGIN
		SET @Where = ' WHERE Lido = 0 ' 
	END
ELSE IF (@TipoPesquisa = 1) -- Lidos
	BEGIN
		SET @Where = ' WHERE Lido = 1 '
	END
ELSE -- Todos
	BEGIN
		SET @Where = ''
	END

execute('
SELECT 
	A.ID_Alerta
	,A.ID_ConfiguracaoAlerta
	,A.DataAlerta
	,A.Valor
	,A.Lido
	,A.DataCiencia
	,A.ID_Usuario
	,U.Login
	,C.Gravidade 
	,C.Descricao as DescricaoAlerta
	,TIA.Descricao as DescricaoICAtributo
	,I.Descricao as DescricaoIC
FROM
	Alerta A
	LEFT JOIN ConfiguracaoAlerta C ON C.ID_ConfiguracaoAlerta = A.ID_ConfiguracaoAlerta
	LEFT JOIN Usuario U ON U.ID_Usuario = A.ID_Usuario
	LEFT JOIN ICAtributo IA ON IA.ID_ICAtributo = C.ID_ICAtributo
	LEFT JOIN TipoICAtributo TIA ON TIA.ID_TipoICAtributo = IA.ID_TipoICAtributo
	LEFT JOIN IC I ON I.ID_IC = IA.ID_IC
' + @Where)
  
  
  